//



// =================================
int State2D = 0;


int Begin2D(double LBort, double RBort, double Niz, double Top )
{
	if( State2D > 0 ) return 0; //    2  
	State2D = 1;
	glDisable( GL_DEPTH_TEST ); glDepthMask( GL_FALSE );

	glMatrixMode(GL_PROJECTION); glPushMatrix(); glLoadIdentity();

		gluOrtho2D( LBort, RBort, Niz, Top );
		//The gluOrtho2D function sets up a two-dimensional orthographic viewing region.
		//This is equivalent to calling glOrtho with near = 1 and far = 1.

	glMatrixMode(GL_MODELVIEW); glPushMatrix(); glLoadIdentity();
return 1;
}

void End2D()
{
	if( State2D < 1 ) return;	//  2   
	if( State2D == 1 )
	{	glEnable( GL_DEPTH_TEST ); glDepthMask( GL_TRUE );
	}
	State2D = 0;

	glMatrixMode( GL_MODELVIEW ); glPopMatrix();
	glMatrixMode( GL_PROJECTION ); glPopMatrix();
	glMatrixMode( GL_MODELVIEW );
}




// NomBlend(0) =       . // 39 40
void NomBlend( int nom=34 )
{
	if(nom < 1) { glDisable(GL_BLEND); return; }

	glEnable(GL_BLEND);

  switch( nom )
  {
  case 1: glBlendFunc(GL_ZERO, GL_ZERO); break; // 0000  0000 = 0
  case 2: glBlendFunc(GL_ZERO, GL_ONE); break; // 0000  1111 = 0
  case 3: glBlendFunc(GL_ZERO, GL_SRC_COLOR); break; // 0000  - = 0
  case 4: glBlendFunc(GL_ZERO, GL_ONE_MINUS_SRC_COLOR); break; // 0000  (1111 - -) = 0
  case 5: glBlendFunc(GL_ZERO, GL_SRC_ALPHA); break; // 0000  -/-
  case 6: glBlendFunc(GL_ZERO, GL_ONE_MINUS_SRC_ALPHA); break; // 0000  (1111 - ...
  case 7: glBlendFunc(GL_ZERO, GL_DST_ALPHA); break; // 0000 
  case 8: glBlendFunc(GL_ZERO, GL_ONE_MINUS_DST_ALPHA); break; // 0000 
  case 12: glBlendFunc(GL_ONE, GL_ONE_MINUS_SRC_COLOR); break; //transparency
  case 19: glBlendFunc(GL_DST_COLOR, GL_SRC_COLOR); break; //for lightmapping

	  // --------------------------------  ..
	  // GL_SRC_ALPHA   -  -   .
  case 33: glBlendFunc(GL_SRC_ALPHA, GL_ZERO); break; //    ( )
  case 34: glBlendFunc(GL_SRC_ALPHA, GL_ONE); break; //     () ( )
  case 38: glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA); break; //Transparency
  case 39: glBlendFunc(GL_SRC_ALPHA, GL_DST_ALPHA); break; //  -
  case 40: glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_DST_ALPHA); break; //  -
  default: glBlendFunc(GL_SRC_ALPHA, GL_ZERO); break; //33
  }

}

void white_mat_front()
{
	float Amb[3] = {0.f, 0.f, 0.f};
	float Dif[3] = {1.f, 1.f, 1.f};
	glMaterialfv(GL_FRONT, GL_AMBIENT, &Amb[0]);
	glMaterialfv(GL_FRONT, GL_DIFFUSE, &Dif[0]);
	glMaterialfv(GL_FRONT, GL_SPECULAR, &Amb[0]);
	glMaterialfv(GL_FRONT, GL_EMISSION, &Amb[0]);
	glMaterialf(GL_FRONT, GL_SHININESS, 0.f);
}

// ColorMat(0) =  .  ColorMat() = .
void ColorMat(BYTE alfa=255, BYTE r=255, BYTE g=255, BYTE b=255)
{
	if( alfa )
	{
		glEnable( GL_COLOR_MATERIAL); white_mat_front();
		glColor4ub( r, g, b, alfa);
	}
	else { glDisable( GL_COLOR_MATERIAL) ; }

}

 // alfa < 0.001  glDisable(...)
void ColorMatF(float alfa=1.0f, float r=1.0f, float g=1.0f, float b=1.0f)
{
	if( alfa > 0.00001f )//if( alfa > Epsilon1 )
	{
		glEnable( GL_COLOR_MATERIAL); white_mat_front();
		glColor4f( r, g, b, alfa);
	}
	else { glDisable( GL_COLOR_MATERIAL) ; }

}





void glAnLine(float x1, float z1,   float x2, float z2)
{
	glBegin(GL_LINES);
		//glVertex3f( x1, y1, z1);	glVertex3f( x2, y2, z2);
		glVertex2f( x1, z1);	glVertex2f( x2, z2);
	glEnd();
}

void glCross1_2D(int cntrX, int cntrY,  int LLen=5, int RLen=5, int UpLen=5, int DnLen=5)
{
	glBegin(GL_LINES);
		glVertex2f(cntrX - LLen, cntrY);	glVertex2f(cntrX + RLen, cntrY);
		glVertex2f(cntrX, cntrY + UpLen);	glVertex2f(cntrX, cntrY - DnLen);
	glEnd();
}




// Fill=0    ...    Begin2D(Ekran) End2D()
void DrawQuad2D_(float x, float y, float w, float h, int Fill=1, float dnV =0.f, float upV =1.f)
{
	if(State2D != 1) return;
	if(! Fill) glPolygonMode(GL_FRONT, GL_LINE); else glPolygonMode(GL_FRONT, GL_FILL);

	glLoadIdentity();
	glBegin( GL_QUADS );
		glTexCoord2f( 0.f, dnV );  glVertex2f ( x,     y ); // 
		glTexCoord2f( 1.f, dnV );  glVertex2f ( x + w, y ); // 
		glTexCoord2f( 1.f, upV );  glVertex2f ( x + w, y + h ); // 
		glTexCoord2f( 0.f, upV );  glVertex2f ( x, y + h ); // 
	glEnd();

	if(! Fill) glPolygonMode(GL_FRONT, GL_FILL);
}

void DrawQuad2D_2(float x1, float y1, float x2, float y2, int Fill=1)
{
	//   x2  x1  -   ...
	//    -    .
	//DrawQuad2D_( x1, y1, x2 - x1, y2 - y1, Fill);
	float h = y1 - y2; if(y1 < y2) h = y2 - y1;
	DrawQuad2D_( x1, y2, x2 - x1, h, Fill); //     ...
}

void DrawQuad2D_2tcw(float x1, float y1, float x2, float y2, float dnV =1.f, float upV =0.f)
{
	if(State2D != 1) return;

	float h = y1 - y2; if(y1 < y2) h = y2 - y1;
	float w = x2 - x1;
	float x = x1;
	float y = y2;
	glPolygonMode(GL_FRONT, GL_FILL);
	glLoadIdentity();
	glBegin( GL_QUADS );
		glTexCoord2f( 0.f, dnV );  glVertex2f ( x,     y ); // 
		glTexCoord2f( 1.f, dnV );  glVertex2f ( x + w, y ); // 
		glTexCoord2f( 1.f, upV );  glVertex2f ( x + w, y + h ); // 
		glTexCoord2f( 0.f, upV );  glVertex2f ( x, y + h ); // 
	glEnd();
}



// Fill=0    ...    Begin2D(Ekran) End2D()
void DrawQ2D_freeDX( float x1, float y1, float x2, float y2, float x3, float y3,
	float x4, float y4,  int Fill=1)
{
	if(State2D != 1) return;
	if(! Fill) glPolygonMode(GL_FRONT, GL_LINE); else glPolygonMode(GL_FRONT, GL_FILL);

// 12  // directX version
// 43
	glLoadIdentity();
	glBegin( GL_QUADS );
		glTexCoord2f( 0.f, 0.f );  glVertex2f( x4, y4); // 
		glTexCoord2f( 1.f, 0.f );  glVertex2f( x3, y3); // 
		glTexCoord2f( 1.f, 1.f );  glVertex2f( x2, y2);
		glTexCoord2f( 0.f, 1.f );  glVertex2f( x1, y1);
	glEnd();

	if(! Fill) glPolygonMode(GL_FRONT, GL_FILL);
}




void ReshapeGL(int width, int height)
{
	glViewport (0, 0, (GLsizei)(width), (GLsizei)(height));
	glMatrixMode (GL_PROJECTION); glLoadIdentity ();
	gluPerspective (45.0f, (GLfloat)(width)/(GLfloat)(height), 1.0f, 100.0f);
	glMatrixMode (GL_MODELVIEW); glLoadIdentity ();
}


void DisTexAndGenST()
{
	glDisable(GL_TEXTURE_2D); glDisable(GL_TEXTURE_GEN_S); glDisable(GL_TEXTURE_GEN_T);
}





	//    2D Mode
void LineVGra2(int y1, int yMid, int y2, int xxx,
						BYTE y1R, BYTE y1G, BYTE y1B,
							BYTE yMR, BYTE yMG, BYTE yMB)
{
		glBegin(GL_LINES);

			glColor3ub(y1R, y1G, y1B);	glVertex2i( xxx, y1);
			glColor3ub(yMR, yMG, yMB);	glVertex2i( xxx, yMid);
			//glColor3ub(yMR, yMG, yMB);
			glVertex2i( xxx, yMid);
			glColor3ub(y1R, y1G, y1B);	glVertex2i( xxx, y2);

		glEnd();
}




	//    2D Mode
void LineGGra2(int x1, int xMid, int x2, int yyy,
						BYTE x1R, BYTE x1G, BYTE x1B,
							BYTE xMR, BYTE xMG, BYTE xMB)
{
		glBegin(GL_LINES);

			glColor3ub(x1R, x1G, x1B);	glVertex2i( x1, yyy);
			glColor3ub(xMR, xMG, xMB);	glVertex2i( xMid, yyy);
			//glColor3ub(xMR, xMG, xMB);
			glVertex2i( xMid, yyy);
			glColor3ub(x1R, x1G, x1B);	glVertex2i( x2, yyy);

		glEnd();
}






		// - ...
//static
void AlfGraVerti_Q2D( float grayC, float topA, float dnA,
					  float x, float y, float w, float h,   int Fill=1 )
{
	if ( State2D != 1 ) return;

	if(! Fill) glPolygonMode(GL_FRONT, GL_LINE);

	//glEnable(GL_ALPHA_TEST);
	//glAlphaFunc(GL_GREATER, 0.05f);

	glLoadIdentity();

	glBegin ( GL_QUADS );
		glColor4f( grayC, grayC, grayC, dnA );	glTexCoord2f ( 0.0f, 0.0f );
		//glMultiTexCoord2fARB(GL_TEXTURE1_ARB, 0.f, 0.f );
		glVertex2f ( x,     y ); // 

		glColor4f( grayC, grayC, grayC, dnA );	glTexCoord2f ( 1.0f, 0.0f );
		//glMultiTexCoord2fARB(GL_TEXTURE1_ARB, 1.f, 0.f );
		glVertex2f ( x + w, y ); // 

		glColor4f( grayC, grayC, grayC, topA );	glTexCoord2f ( 1.0f, 1.0f );
		//glMultiTexCoord2fARB(GL_TEXTURE1_ARB, 1.f, 1.f );
		glVertex2f ( x + w, y + h ); // 

		glColor4f( grayC, grayC, grayC, topA );	glTexCoord2f ( 0.0f, 1.0f );
		//glMultiTexCoord2fARB(GL_TEXTURE1_ARB, 0.f, 1.f );
		glVertex2f ( x, y + h ); // 

	glEnd();

	//glDisable(GL_ALPHA_TEST);

	if(! Fill) glPolygonMode(GL_FRONT, GL_FILL);

}






		// - ...
//static
void AlfGraGoriz_Q2D (
					float grayC, float LeftA, float RightA,
					  float x, float y, float w, float h,
					  int Fill=1 )
{
	if ( State2D != 1 ) return;

	if(! Fill) glPolygonMode(GL_FRONT, GL_LINE);

	glLoadIdentity();

	glBegin ( GL_QUADS );
		glColor4f( grayC, grayC, grayC, LeftA );	glTexCoord2f ( 0.0f, 0.0f );
		//glMultiTexCoord2fARB(GL_TEXTURE1_ARB, 0.f, 0.f );
		glVertex2f ( x,     y ); // 

		glColor4f( grayC, grayC, grayC, RightA );	glTexCoord2f ( 1.0f, 0.0f );
		//glMultiTexCoord2fARB(GL_TEXTURE1_ARB, 1.f, 0.f );
		glVertex2f ( x + w, y ); // 

		glColor4f( grayC, grayC, grayC, RightA );	glTexCoord2f ( 1.0f, 1.0f );
		//glMultiTexCoord2fARB(GL_TEXTURE1_ARB, 1.f, 1.f );
		glVertex2f ( x + w, y + h ); // 

		glColor4f( grayC, grayC, grayC, LeftA );	glTexCoord2f ( 0.0f, 1.0f );
		//glMultiTexCoord2fARB(GL_TEXTURE1_ARB, 0.f, 1.f );
		glVertex2f ( x, y + h ); // 

	glEnd();

	if(! Fill) glPolygonMode(GL_FRONT, GL_FILL);

}












		// - ... (  RGB)
//static
void AlfGraVertiClr_Q2D (
					float RC, float GC, float BC,
					float topA, float dnA,
					  float x, float y, float w, float h,
					  int Fill=1 )
{
	if ( State2D != 1 ) return;

	if(! Fill) glPolygonMode(GL_FRONT, GL_LINE);

	glLoadIdentity();

	glBegin ( GL_QUADS );
		glColor4f( RC, GC, BC, dnA );	glTexCoord2f ( 0.0f, 0.0f );
		//glMultiTexCoord2fARB(GL_TEXTURE1_ARB, 0.f, 0.f );
		glVertex2f ( x,     y ); // 

		glColor4f( RC, GC, BC, dnA );	glTexCoord2f ( 1.0f, 0.0f );
		//glMultiTexCoord2fARB(GL_TEXTURE1_ARB, 1.f, 0.f );
		glVertex2f ( x + w, y ); // 

		glColor4f( RC, GC, BC, topA );	glTexCoord2f ( 1.0f, 1.0f );
		//glMultiTexCoord2fARB(GL_TEXTURE1_ARB, 1.f, 1.f );
		glVertex2f ( x + w, y + h ); // 

		glColor4f( RC, GC, BC, topA );	glTexCoord2f ( 0.0f, 1.0f );
		//glMultiTexCoord2fARB(GL_TEXTURE1_ARB, 0.f, 1.f );
		glVertex2f ( x, y + h ); // 

	glEnd();

	if(! Fill) glPolygonMode(GL_FRONT, GL_FILL);

}






		// - ... (  RGB)
//static
void AlfGraGorizClr_Q2D (
					float RC, float GC, float BC,
					float LeftA, float RightA,
					  float x, float y, float w, float h,
					  int Fill=1 )
{
	if ( State2D != 1 ) return;

	if(! Fill) glPolygonMode(GL_FRONT, GL_LINE);

	glLoadIdentity();

	glBegin ( GL_QUADS );
		glColor4f( RC, GC, BC, LeftA );	glTexCoord2f ( 0.0f, 0.0f );
		//glMultiTexCoord2fARB(GL_TEXTURE1_ARB, 0.f, 0.f );
		glVertex2f ( x,     y ); // 

		glColor4f( RC, GC, BC, RightA );	glTexCoord2f ( 1.0f, 0.0f );
		//glMultiTexCoord2fARB(GL_TEXTURE1_ARB, 1.f, 0.f );
		glVertex2f ( x + w, y ); // 

		glColor4f( RC, GC, BC, RightA );	glTexCoord2f ( 1.0f, 1.0f );
		//glMultiTexCoord2fARB(GL_TEXTURE1_ARB, 1.f, 1.f );
		glVertex2f ( x + w, y + h ); // 

		glColor4f( RC, GC, BC, LeftA );	glTexCoord2f ( 0.0f, 1.0f );
		//glMultiTexCoord2fARB(GL_TEXTURE1_ARB, 0.f, 1.f );
		glVertex2f ( x, y + h ); // 

	glEnd();

	if(! Fill) glPolygonMode(GL_FRONT, GL_FILL);

}












// left rit up dn

float AlfGraClrRam_s54_Def[] =
{
1.f,  1.f,  1.f,   0.9f,  0.08f,//0 1 2 3 4
0.8f, 0.8f, 0.8f,  0.08f, 0.9f, //5 6 7 8 9
1.f,  1.f,  1.f,   0.08f, 0.9f, //10 11 12 13 14
0.7f, 0.7,  0.7f,  0.9f,  0.08f //15 16 17 18 19
};


void AlfGraClrRam( float* s54,
	float X, float Y, float W, float H, float Bd, int outer=1,
			  BYTE bcR1=127, BYTE bcG1=127, BYTE bcB1=127,
			  BYTE bcRm=0, BYTE bcGm=0, BYTE bcBm=0)
{
	if( ! s54)
	{
		s54 = &AlfGraClrRam_s54_Def[0];
	}
	if(outer)
	{
		X -= Bd;
		Y -= Bd;
		H += Bd * 2;
		W += Bd * 2;
	}
	int hH = H/2;
	int YhH = Y+hH;
	int YH = Y+H;

	int hW = W/2;
	int XhW = X+hW;
	int XW = X+W;


AlfGraGorizClr_Q2D(s54[0],s54[1],s54[2],s54[3],s54[4], XW-Bd, Y, Bd, H ); //left

		LineVGra2(Y, YhH, YH, XW,		bcR1,bcG1,bcB1,  bcRm,bcGm,bcBm);
		LineVGra2(Y, YhH, YH, XW - Bd,	bcR1,bcG1,bcB1,  bcRm,bcGm,bcBm);

AlfGraGorizClr_Q2D(s54[5],s54[6],s54[7],s54[8],s54[9], X, Y, Bd, H ); //rit

		LineVGra2(Y, YhH, YH, X,     bcR1,bcG1,bcB1,  bcRm,bcGm,bcBm);
		LineVGra2(Y, YhH, YH, X + Bd, bcR1,bcG1,bcB1,  bcRm,bcGm,bcBm);

AlfGraVertiClr_Q2D(s54[10],s54[11],s54[12],s54[13],s54[14],  X, YH-Bd, W, Bd );

		LineGGra2( X, XhW, XW, YH,		bcR1,bcG1,bcB1,  bcRm,bcGm,bcBm);
		LineGGra2( X, XhW, XW, YH - Bd,	bcR1,bcG1,bcB1,  bcRm,bcGm,bcBm);

AlfGraVertiClr_Q2D(s54[15],s54[16],s54[17],s54[18],s54[19], X, Y, W, Bd ); // dn

		LineGGra2( X, XhW, XW, Y,		bcR1,bcG1,bcB1,  bcRm,bcGm,bcBm);
		LineGGra2( X, XhW, XW, Y + Bd,	bcR1,bcG1,bcB1,  bcRm,bcGm,bcBm);

}















void Kubik(float cx, float cy, float cz, float halfSize)
{
	float x1 = cx - halfSize;
	float x2 = cx + halfSize;
	float y1 = cy - halfSize;
	float y2 = cy + halfSize;
	float z1 = cz - halfSize;
	float z2 = cz + halfSize; //front  

	glBegin(GL_QUADS);
		// front
		glVertex3f( x1, y1, z2);		glVertex3f( x2, y1, z2); //  
		glVertex3f( x2, y2, z2);		glVertex3f( x1, y2, z2); //  

		// back
		glVertex3f( x2, y1, z1);		glVertex3f( x1, y1, z1);
		glVertex3f( x1, y2, z1);		glVertex3f( x2, y2, z1);

		// left (view from top)
		glVertex3f( x1, y1, z1);		glVertex3f( x1, y1, z2);
		glVertex3f( x1, y2, z2);		glVertex3f( x1, y2, z1);

		// right
		glVertex3f( x2, y1, z2);		glVertex3f( x2, y1, z1);
		glVertex3f( x2, y2, z1);		glVertex3f( x2, y2, z2);

		// top
		glVertex3f( x1, y2, z2);		glVertex3f( x2, y2, z2); //  
		glVertex3f( x2, y2, z1);		glVertex3f( x1, y2, z1); //  

		// bottom
		glVertex3f( x1, y1, z1);		glVertex3f( x2, y1, z1); //  
		glVertex3f( x2, y1, z2);		glVertex3f( x1, y1, z2); //  
	glEnd();
}



void Kubik(float cx, float cy, float cz, float halfX, float halfY, float halfZ)
{
	float x1 = cx - halfX;
	float x2 = cx + halfX;
	float y1 = cy - halfY;
	float y2 = cy + halfY;
	float z1 = cz - halfZ;
	float z2 = cz + halfZ; //front  

	glBegin(GL_QUADS);
		// front
		glVertex3f( x1, y1, z2);	glVertex3f( x2, y1, z2); //  
		glVertex3f( x2, y2, z2);	glVertex3f( x1, y2, z2); //  

		// back
		glVertex3f( x2, y1, z1);	glVertex3f( x1, y1, z1);
		glVertex3f( x1, y2, z1);	glVertex3f( x2, y2, z1);

		// left (view from top)
		glVertex3f( x1, y1, z1);	glVertex3f( x1, y1, z2);
		glVertex3f( x1, y2, z2);	glVertex3f( x1, y2, z1);

		// right
		glVertex3f( x2, y1, z2);	glVertex3f( x2, y1, z1);
		glVertex3f( x2, y2, z1);	glVertex3f( x2, y2, z2);

		// top
		glVertex3f( x1, y2, z2);	glVertex3f( x2, y2, z2); //  
		glVertex3f( x2, y2, z1);	glVertex3f( x1, y2, z1); //  

		// bottom
		glVertex3f( x1, y1, z1);	glVertex3f( x2, y1, z1); //  
		glVertex3f( x2, y1, z2);	glVertex3f( x1, y1, z2); //  
	glEnd();
}












void Fog_off(){glDisable(GL_FOG);}

void Fog_set(int nom,
	float fogR = 0.5f, float fogG = 0.5f, float fogB = 0.5f, float fogA = 0.5f,
	float fogNear = 350.f, float fogFar = 450.f)
{
	static float cv4[4] = {0.5f, 0.5f, 0.5f, 1.f};

	switch(nom)
	{
	case 1:
		cv4[0] = fogR;  cv4[1] = fogG;  cv4[2] = fogB;  cv4[3] = fogA;
		glFogfv(GL_FOG_COLOR, cv4);
		glFogi(GL_FOG_MODE, GL_LINEAR);
		glFogf(GL_FOG_START, fogNear );
		glFogf(GL_FOG_END, fogFar );
		glEnable(GL_FOG);
	break;

	case 2:
		cv4[0] = fogR;  cv4[1] = fogG;  cv4[2] = fogB;  cv4[3] = fogA;
		glFogfv(GL_FOG_COLOR, cv4);
		glFogi(GL_FOG_MODE, GL_EXP);
		glFogf(GL_FOG_DENSITY, 0.005f);
		glEnable(GL_FOG);
	break;

	default:
		glDisable(GL_FOG);
	break;
	}

	//	GL_LINEAR   GL_FOG_START & GL_FOG_END
	//   -  GL_FOG_DENSITY ...
	//GL_EXP & GL_EXP2   DENSITY   ...
		//Only nonnegative densities are accepted. The default fog density is 1.0.

}














#define FDI(a, b)  (float(a) / float(b))
#define DDI(a, b)  ( double( (float)a / (float)b ) )
#define FMI(a, b)  (float(a) * float(b))
#define DMI(a, b)  ( double( (float)a * (float)b ) )



void vecFromAngr( float* arr3, float radUg, float mnoj)
{	// ---   ,    
	arr3[0] = -sin( double(radUg) ) * mnoj; // sin //  include/math.h
	arr3[1] = 0.f;
	arr3[2] = cos( double(radUg) ) * mnoj;
}


	//       
int SwapIntFlg( int& anInt )
{
	if(anInt > 0)	{	anInt = 0;	return 0;	}
	else anInt = 1;

	return 1;
}


//int org2n_EngText(){return org2n[org2::EngText];}
int org2n_EngText(){return 1;}

inline int Rand2( int mini=1, int maxi=6)
{
    return ( rand() % (maxi-mini+1) ) + mini;
}

inline float Rand2F( float mini=0.0f, float maxi=1.0f, int dolei=100)
{
return  float( rand() % dolei + 1)  *  ((maxi - mini) / float(dolei))  + mini;
}


//float flob(float valByte)
//{
//	if(valByte < 1.f) return 0.f;
//	if(valByte > 254.f) return 1.f;
//	return valByte / 255.f;
//}


//inline std::string IntToS(int i)
//{
//char buf[32];
//	_itoa(i, buf, 10); //  
//	return std::string(buf);
//}

//extern sStr IntToS(int i, int minimChars);



std::string StrFmt( const char* fmt, ...)
{
	if(fmt == 0) return "";
	char buf[200]={0};

va_list args;

	va_start(args, fmt); //      ??
		vsprintf( buf, fmt, args); //   (varia TO string print format)
		//vfprintf( file, fmt, args); //    (varia TO file print format)
	va_end(args);
	return buf;
}
//void test_primer_frm221()
//{
//SYSTEMTIME stime;
//std::string s0;
//	GetLocalTime( &stime );
//
//	s0 = StrFmt(
//		"%04d_%02d_d%02d__%02d_%02dm_%02ds__%s.bmp", //   
//			stime.wYear, stime.wMonth, stime.wDay, stime.wHour, stime.wMinute, stime.wSecond,
//				stringX.c_str()  );
//}




int ASyncKey(int virtKeyCode)
{
	if( virtKeyCode < 1) return 0;
	if( GetAsyncKeyState(virtKeyCode) & 0x8000 ) return 1;
	return 0;
}




void RootFrameTime();





// -*-*-*-*-*-*-

void LogInfo(const char *string, ...)
{
	static int klvMsgMax =3500;
	static int klvMsg =0;

	if( klvMsg >= klvMsgMax ) return;

	va_list args;
	FILE* log_file;


	log_file = fopen( log1_file_name.c_str(), "a+t");
	if( ! log_file ) return;



	va_start(args, string);
	vfprintf(log_file, string, args);
	va_end(args);



	klvMsg += 1;
	if( klvMsg == klvMsgMax )
	{
		fprintf(log_file, "\n(%d) so mach msgs and log-sys close ...\n", klvMsg);
		fclose(log_file);
	}

	fclose(log_file);
}







void TetSpeDrawOnPause()
{
	if(0)
	{
		glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	}else
	{
	Begin2D(0, g_wnd_w, 0, g_wnd_h );
	NomBlend(38); ColorMatF(0.7f,   0.f, 0.2f, 0.4f); pix1.off();
		DrawQuad2D_(0, 0, g_wnd_w, g_wnd_h);
	End2D();
	}

	print1.frz( "PAUSE", 6,  50, 150,   0,0, g_wnd_w, g_wnd_h, "aqpcg");

	SwapBuffers( hDC);
}






std::vector<std::string> msgbase;

void MsgBaseLoad(std::string fName)
{
	using namespace std;

	int klv;
	//string s1;
	ifstream frs;


	frs.open( fName.c_str() ); if( ! frs.is_open() ) return;

	msgbase.clear();

	frs >> klv; // 
		if(klv < 2){frs.close(); return;}
		streamGetToZ1310( frs );// 

	for(int i=0; i < klv; i++)
	{
		getline(frs, fName);//
		getline(frs, fName); msgbase.push_back(fName);
		getline(frs, fName); msgbase.push_back(fName);
	}
	frs.close();
}


const char* MsgBase(int nom)
{
	if( msgbase.empty() ) return "...";

if(nom < 1) return ".0."; //  
if( (nom * 2 - 1) > (msgbase.size()-1) ) return ".Z.";

if( org2n[org2::EngText] )
	return msgbase[(nom * 2) - 2].c_str();
else return msgbase[(nom * 2) - 1].c_str();

//return (const char*) ...

}




int getdir1(std::string dir, std::vector<std::string> &files)
{
    DIR *dp;
    struct dirent *dirp;
    if((dp  = opendir(dir.c_str())) == NULL) return 0;

    while ((dirp = readdir(dp)) != NULL)
    {
        files.push_back(std::string(dirp->d_name));
    }
    closedir(dp);
    return 1;
}











void set4flo( float* a, float a0,float a1,float a2,float a3)
{	a[0] = a0;  a[1] = a1;  a[2] = a2;  a[3] = a3;
}

void set8flo( float* a, float a0,float a1,float a2,float a3,float a4,float a5,float a6,float a7)
{	a[0] = a0;  a[1] = a1;  a[2] = a2;  a[3] = a3;
	a[4] = a4;  a[5] = a5;  a[6] = a6;  a[7] = a7;
}

void set16flo( float* a,
	float a0,float a1,float a2,float a3,float a4,float a5,float a6,float a7,
	float a8,float a9,float a10,float a11,float a12,float a13,float a14,float a15)
{
	a[0] = a0;   a[1] = a1;   a[2] = a2;  a[3] = a3;  a[4] = a4;  a[5] = a5;  a[6] = a6;  a[7] = a7;
	a[8] = a8;   a[9] = a9;   a[10]=a10; a[11]=a11; a[12]=a12; a[13]=a13; a[14]=a14; a[15]=a15;
}

void set16flo( float* a,
	float a0,float a1,float a2,float a3)
{
/*	a[0] = a0;	a[4] = a0;	a[8] = a0;	a[12]= a0;
	a[1] = a1;	a[5] = a1;	a[9] = a1;	a[13]= a1;
	a[2] = a2;	a[6] = a2;	a[10]= a2;	a[14]= a2;
	a[3] = a3;	a[7] = a3;	a[11]=a3;	a[15]=a3; */

	a[0] = a[4] = a[8] = a[12]= a0;
	a[1] = a[5] = a[9] = a[13]= a1;
	a[2] = a[6] = a[10]= a[14]= a2;
	a[3] = a[7] = a[11]= a[15]= a3;
}










void glSetARGB( DWORD clr)
{
	GLubyte* bal = (GLubyte*)&clr; bal = bal +3;
	GLubyte* bre = (GLubyte*)&clr; bre = bre +2;
	GLubyte* bgr = (GLubyte*)&clr; bgr = bgr +1;
	GLubyte* bbl = (GLubyte*)&clr;

	glColor4ub( *bre, *bgr, *bbl, *bal);

//    0xFF880000 ABGR //   
//    " "    88  FF
//	glColor4ubv( (GLubyte*)&clr);
}





// ---
//     (-)

void an1_dr_r(float x, float y, float w, float h, DWORD clr)
{
	glSetARGB( clr);

	NomBlend(0);  pix1.off();
	DrawQuad2D_( x, y,  w, h, 0);
}

void an1_dr_r2(float x, float y, float x2, float y2, DWORD clr)
{
	glSetARGB( clr);

	NomBlend(0);  pix1.off();
	DrawQuad2D_2( x, y,  x2, y2, 0);

}







